unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Buttons, StdCtrls;

const si=250; // !!!!
      sii=si-1;

type
  dinar = array [0..sii,0..sii] of integer;
  pdinar = ^dinar;

 type
 TRGB = record
 b, g, r: byte;
 end;
 ARGB = array[0..si] of TRGB;
 PARGB = ^ARGB;

  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    procedure Calculate;
  end;

var
  Form1: TForm1;
  ar1,ar2: dinar;
  par1, par2, p: pdinar;
  // soot: array [0..4] of cardinal = (clred, clblue, clwhite, clgreen, clyellow);
  soot: array [0..4] of byte = (0, 64, 128, 192, 255);
  ing, cat:integer;
  bi: TBitMap;
  trig: boolean;

implementation

{$R *.dfm}

function ZFill(const s: string; const len: Integer): string;
var
  c: Integer;
begin
  Result := s;            
  c := len - length(s);
  if c<0 then Exit;
  while c<>0 do begin
    Result := '0'+Result;
    Dec(c);
  end;
end;

procedure TForm1.Calculate;
 var i,j,k0,k2,i0,i2,j0,j2:integer;
 z: array of integer;
 p: PARGB;
begin
 for i:=0 to sii do begin
  p := bi.scanline[i];
  for j:=0 to sii do begin
  
   z:=nil;
   setlength(z,5);

   i0:=i-1;
   i2:=i+1;
   j0:=j-1;
   j2:=j+1;

   if i0<0 then i0:=sii;
   if j0<0 then j0:=sii;
   if i2>sii then i2:=0;
   if j2>sii then j2:=0;

   inc(z[par1^[i,j0]]);
   inc(z[par1^[i,j2]]);
   inc(z[par1^[i0,j]]);
   inc(z[par1^[i2,j]]);
   inc(z[par1^[i0,j2]]);
   inc(z[par1^[i0,j0]]);
   inc(z[par1^[i2,j0]]);
   inc(z[par1^[i2,j2]]);

   k0:=par1^[i,j]-1;
   k2:=par1^[i,j]+1;
   if k0<0 then k0:=4;
   if k2>4 then k2:=0;

   if (z[k0]<ing) and (z[k2]>cat) then par2[i,j]:=k2 else par2[i,j]:=par1[i,j];
   p[j].g:=soot[par2[i,j]];
  end;
 end;
 form1.canvas.draw(10, 10, bi);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 form1.DoubleBuffered:=true;
 bi := TBitMap.Create;
 bi.pixelformat := pf24bit;
 bi.width := si;
 bi.height := si;
end;

procedure TForm1.Button1Click(Sender: TObject);
 var i,j:cardinal;
begin
 if button1.Caption= 'Start' then begin
  edit1.Enabled:=false;
  edit2.Enabled:=false;
  label1.Enabled:=false;
  label2.Enabled:=false;
  trig:=true;
  par1:=@ar1;
  par2:=@ar2;
  button1.Caption:= 'Stop';
  randomize;
  for i:=0 to sii do
  for j:=0 to sii do begin
   ar1[i,j]:=random(5);
   ar2[i,j]:=ar1[i,j];
  end;
   ing:=strtoint(edit2.Text);
   cat:=strtoint(edit1.Text);
  while trig do begin
   p:=par1;
   par1:=par2;
   par2:=p;
   Calculate;
   application.ProcessMessages;
  end;
 end else begin
  trig:=false;
  button1.Caption:= 'Start';
  edit1.Enabled:=true;
  edit2.Enabled:=true;
  label1.Enabled:=true;
  label2.Enabled:=true;
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 trig:=false;
 bi.Free;
end;

end.
