unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Buttons, StdCtrls, ExtCtrls;

const si=200; // !
      sii=si-1;

type
  dinar = array [0..sii,0..sii] of integer;
  pdinar = ^dinar;

 type
 TRGB = record
 b, g, r: byte;
 end;
 ARGB = array[0..si] of TRGB;
 PARGB = ^ARGB;

  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Calculate;
  end;

var
  Form1: TForm1;
  ar1,ar2: dinar;
  par1, par2, p: pdinar;

  sootR: array [0..4] of byte = (255, 255, 255, 0,   0);
  sootG: array [0..4] of byte = (0,   200, 255, 255, 0);
  sootB: array [0..4] of byte = (0,   150, 255, 0,   255);

  ing, cat:integer;
  bi: TBitMap;
  trig,trig2: boolean;

implementation

{$R *.dfm}

procedure TForm1.Calculate;
 var i,j,k2,i0,i2,i3,i4,j0,j2,j3,j4:integer;
 z: array of integer;
 p: PARGB;
begin
 for i:=0 to sii do begin
  p := bi.scanline[i];
  for j:=0 to sii do begin
  
   z:=nil;
   setlength(z,5);

   i0:=i-1;
   i2:=i+1;
   j0:=j-1;
   j2:=j+1;

   if i0<0 then i0:=sii;
   if j0<0 then j0:=sii;
   if i2>sii then i2:=0;
   if j2>sii then j2:=0;

   inc(z[par1[i,j0]]);
   inc(z[par1[i,j2]]);
   inc(z[par1[i0,j]]);
   inc(z[par1[i2,j]]);
   inc(z[par1[i0,j2]]);
   inc(z[par1[i0,j0]]);
   inc(z[par1[i2,j0]]);
   inc(z[par1[i2,j2]]);

   if trig2 then begin

    j3:=j+2;
    j4:=j-2;
    i3:=i+2;
    i4:=i-2;

    if j3=(sii+1) then j3:=0;
    if j3=(sii+2) then j3:=1;
    if i3=(sii+1) then i3:=0;
    if i3=(sii+2) then i3:=1;
    if j4=-1 then j4:=sii;
    if j4=-2 then j4:=sii-1;
    if i4=-1 then i4:=sii;
    if i4=-2 then i4:=sii-1;

    inc(z[par1[i,j3]]);
    inc(z[par1[i,j4]]);
    inc(z[par1[i0,j3]]);
    inc(z[par1[i0,j4]]);
    inc(z[par1[i2,j3]]);
    inc(z[par1[i2,j4]]);
    inc(z[par1[i3,j]]);
    inc(z[par1[i4,j]]);
    inc(z[par1[i3,j0]]);
    inc(z[par1[i4,j0]]);
    inc(z[par1[i3,j2]]);
    inc(z[par1[i4,j2]]);
    inc(z[par1[i3,j3]]);
    inc(z[par1[i3,j4]]);
    inc(z[par1[i4,j3]]);
    inc(z[par1[i4,j4]]);
   end;

   k2:=par1[i,j]+1;
   if k2>4 then k2:=0;

   if z[k2]=cat then par2[i,j]:=k2 else par2[i,j]:=par1[i,j];
   p[j].r:=sootR[par2[i,j]];
   p[j].g:=sootG[par2[i,j]];
   p[j].b:=sootB[par2[i,j]];
  end;
 end;
 form1.image1.Picture.Bitmap.canvas.draw(0, 0, bi);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 image1.Picture.Bitmap.Width:=si;
 image1.Picture.Bitmap.Height:=si;
 trig2:=checkbox1.Checked;;
 form1.DoubleBuffered:=true;
 bi := TBitMap.Create;
 bi.pixelformat:=pf24bit;
 bi.width := si;
 bi.height := si;
end;

procedure TForm1.Button1Click(Sender: TObject);
 var i,j:cardinal;
begin
 if button1.Caption= 'Start' then begin

  trig:=true;
  par1:=@ar1;
  par2:=@ar2;
  button1.Caption:= 'Stop';
  randomize;
  for i:=0 to sii do
  for j:=0 to sii do begin
   ar1[i,j]:=random(5);
   ar2[i,j]:=ar1[i,j];
  end;

  while trig do begin
   p:=par1;
   par1:=par2;
   par2:=p;
   Calculate;
   cat:=strtoint(edit1.Text);
   application.ProcessMessages;
  end;
 end else begin
  trig:=false;
  button1.Caption:= 'Start';
 end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 trig:=false;
 bi.Free;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
 trig2:=CheckBox1.checked;
end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
 top:=0;
 left:=0;
 form1.Width:=1024;
 form1.Height:=768;
 image1.Width:=1024;
 image1.Height:=768;
 form1.FormStyle:=fsStayOnTop;
end;

end.
